<?php

if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

class MyPolls_Plugin
{ 
    var $my_config;
    var $plugin_name = 'MyPolls';
    var $prefixeTable;
    var $pagelink= 'admin.php?page=plugin&section=mypolls%2Fadmin%2Fplugin_admin.php';

    var $polls_table; 
    var $polls_by_user_table; 

	/* ----------------------------------------------------------------------------------------------
		FONCTIONS STANDARDS
	   ---------------------------------------------------------------------------------------------- */

	/* initialise le tableau de configuration */
	function init_config()
	{
		$this->my_config=array(
				'MyPolls_MouseOverColor' => '303030',
				'MyPolls_BarColor' => '6666ff',
				'MyPolls_MaxBarWidth' => '400',
				'MyPolls_allow_guests_default' => 'n',
				'MyPolls_visible_default' => 'y',
				'MyPolls_MenuBar_Title' => '',
				//v1.1
				'MyPolls_nbuser_per_page' => 15,
				'MyPolls_enabled_default' => 'y',
				'MyPolls_generic_text_users' => '',
				'MyPolls_generic_text_guests' => '',
				'MyPolls_allow_comment_default' => 'n',
				'MyPolls_show_user_comment_default' => 'n',
				'MyPolls_nbcomment_per_page' => 1,
				//v1.2
				'MyPolls_allowed_users_default_guest' => 'y',
				'MyPolls_allowed_users_default_generic' => 'y',
				'MyPolls_allowed_users_default_normal' => 'y',
				'MyPolls_allowed_groups_default' => '',
				);
	}

	function init($prefixeTable)
	{
		$this->prefixeTable = $prefixeTable;
		$this->polls_table = $this->prefixeTable.$this->plugin_name."_polls";
		$this->polls_by_user_table = $this->prefixeTable.$this->plugin_name."_polls_by_user";
	}

	/* charge la configuration */
	function load_config()
	{
		$this->init_config();
		$sql="SELECT value FROM ".CONFIG_TABLE." WHERE param = '".$this->plugin_name."_config'";
		$result=pwg_query($sql);
		if($result)
		{
			$row=mysql_fetch_row($result);
			if(is_string($row[0])) 
			{
				$c = unserialize($row[0]);
				reset($c);
				while (list($key, $val) = each($c)) 
				{ $this->my_config[$key] = $val; }
			}
		}
	}

	/* sauvegarde de la configuration dans la table config */
	function save_config()
	{
	 $sql="REPLACE INTO ".CONFIG_TABLE." VALUES('".$this->plugin_name."_config', '".serialize($this->my_config)."', '')"; 
	 $result=pwg_query($sql);
	 if($result) { return true; } else { return false; }
	}

	/* suppression de la configuration dans la table config */
	function delete_config()
	{
	 $sql="DELETE FROM ".CONFIG_TABLE." WHERE param='".$this->plugin_name."_config'"; 
	 $result=pwg_query($sql);
	 if($result) { return true; } else { return false; }
	}

	/* intégration du plugin dans l'interface d'administration */
	function plugin_admin_menu($menu)
	{
	 array_push($menu,
	            array(
	                'NAME' => $this->plugin_name,
	                'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/plugin_admin.php')
	                 ));
	 return $menu;
	}

	function Modifie_CSS()
	{
	  global $template;

		$text = "
.TableRow:hover { 
	background-color:#".$this->my_config['MyPolls_MouseOverColor']."; 
	}
.formtable, .formtable P { 
	text-align:left; display:block; 
	}
.polltxt, .polltxt P {
	text-align:left; 
	display:block; 
	margin:8px;
	}
.MyPollBar {
	border:0px; 
	height:8px;
	display: block;
	margin:0px;
	padding:0px;
	left:0;
	position:relative;
	background-color:#".$this->my_config['MyPolls_BarColor']."; top:0px;  
	}";
		$template->assign_block_vars('head_element', array('CONTENT' => '<style type="text/css"> '.$text.' </style>'));
	}


	/* ----------------------------------------------------------------------------------------------
		FONCTIONS A L'INSTALLATION DU PLUGIN
	   ---------------------------------------------------------------------------------------------- */
	
	/* création des tables polls */
	function create_tables()
	{
		//on supprime les tables si elles existent déjà
		$this->drop_tables();

		//v1.0
		$sql="CREATE TABLE `".$this->prefixeTable.$this->plugin_name."_polls` (
			  `id` int(11) NOT NULL auto_increment,
			  `date` datetime NOT NULL default '0000-00-00 00:00:00',
			  `title` varchar(250) NOT NULL default '',
			  `description` text,
			  `allow_guests` char(1) NOT NULL default 'n',
			  `visible` char(1) NOT NULL default 'y',
			  `c1_text` varchar(250) default '',
			  `c1_choose` int(11) NOT NULL default '0',
			  `c2_text` varchar(250) default '',
			  `c2_choose` int(11) NOT NULL default '0',
			  `c3_text` varchar(250) default '',
			  `c3_choose` int(11) NOT NULL default '0',
			  `c4_text` varchar(250) default '',
			  `c4_choose` int(11) NOT NULL default '0',
			  `c5_text` varchar(250) default '',
			  `c5_choose` int(11) NOT NULL default '0',
			  `c6_text` varchar(250) default '',
			  `c6_choose` int(11) NOT NULL default '0',
			  `c7_text` varchar(250) default '',
			  `c7_choose` int(11) NOT NULL default '0',
			  `c8_text` varchar(250) default '',
			  `c8_choose` int(11) NOT NULL default '0',
			  `c9_text` varchar(250) default '',
			  `c9_choose` int(11) NOT NULL default '0',
			  `c10_text` varchar(250) default '',
			  `c10_choose` int(11) NOT NULL default '0',
			  `total` int(11) NOT NULL default '0',
			  `visit_without_vote` int(11) NOT NULL default '0',
			  `visit_after_vote` int(11) NOT NULL default '0', ";
		//v1.1
		$sql.="	  `after_vote_text` text, 
			  `enabled` char(1) NOT NULL default 'y', "; 
		//v1.2
		$sql.="	  `allowed_users` varchar(35) NOT NULL default 'guest/generic/normal/',
			  `allowed_groups` varchar(250) NOT NULL default '', "; 

		$sql.="	  PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1";
		$result=pwg_query($sql);
		if($result)
		{
			//v1.0
			$sql="CREATE TABLE `".$this->prefixeTable.$this->plugin_name."_polls_by_user` (
				  `poll_id` int(11) NOT NULL default '0',
				  `user_id` varchar(15) NOT NULL default '2', "; 
			//v1.1
			$sql.="	  `date` datetime NOT NULL default '0000-00-00 00:00:00', 
				  `user_comment` text, "; 

			$sql.="	  PRIMARY KEY (`poll_id`, `user_id`)
				) ENGINE=MyISAM DEFAULT CHARSET=latin1";
			$result=pwg_query($sql);
			return($result);
			
		}
		//si création échoue, on supprime ce qui a peut-être été créé
		$this->drop_tables();
		return(false);
	}

	/* mise à jour des tables polls */
	function update_tables()
	{
		$sqls[$this->polls_by_user_table]=array("date" => " ADD COLUMN `date` datetime not null default '0000-00-00 00:00:00' AFTER `user_id` ", 
						"user_comment" => " ADD COLUMN `user_comment` text null default '' AFTER `date` ");

		$sqls[$this->polls_table]=array("after_vote_text" => " ADD COLUMN `after_vote_text` text null default '' AFTER `visit_after_vote`",
						"enabled" => " ADD COLUMN `enabled` char not null default 'y' AFTER `after_vote_text`",
						"allow_comment" => " ADD COLUMN `allow_comment` char(1) not null default 'n' AFTER `enabled` ",
						"show_user_comment" => " ADD COLUMN `show_user_comment` char(1) not null default 'n' AFTER `allow_comment` ", 
						"allowed_users" => " ADD COLUMN `allowed_users` varchar(35) not null default 'guest/generic/normal/' AFTER `show_user_comment`",
						"allowed_groups" => " ADD COLUMN `allowed_groups` varchar(250) not null default '' AFTER `allowed_users`");
 
		reset($sqls);
		while (list($key, $val) = each($sqls))
		{
			$sql="SHOW COLUMNS FROM $key";
			$result=pwg_query($sql);
			if($result)
			{
				$columns=array();
				while($row=mysql_fetch_assoc($result))
				{ array_push($columns, $row['Field']); }

				reset($val);
				while (list($attname, $sql) = each($val))
				{
					if(!in_array($attname, $columns))
					{
						$result=pwg_query("ALTER TABLE `$key` ".$sql);
					}
				}
			}
		}
	}

	/* suppression des tables */
	function drop_tables()
	{
		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_polls";
		$result=pwg_query($sql);

		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_polls_by_user";
		$result=pwg_query($sql);
	}

	/* restitue les enumération de la table history */
	function get_section_enum($add)
	{
		$sql = 'SHOW COLUMNS FROM '.HISTORY_TABLE.' LIKE "section"';
		$result=pwg_query($sql);
		if($result)
		{
			$row = mysql_fetch_array($result);
			$list=substr($row['Type'], 5, strlen($row['Type'])-6);
			$returned=explode(',', $list);
			if((strpos($list, "'$add'")===false)&&($add!='')) { array_push($returned, "'$add'"); }
			return($returned);
		}
	}

	function add_enum_to_history()
	{	
		$enums=implode(',', $this->get_section_enum('mypolls'));
		$sql="ALTER TABLE ".HISTORY_TABLE."
				 CHANGE `section` `section` 
				 ENUM (".$enums.") ;";
		$result=pwg_query($sql);
		return($result);
	}


	/* ----------------------------------------------------------------------------------------------
		FONCTIONS DIVERSES
	   ---------------------------------------------------------------------------------------------- */

	 /* ------------------------------------------------------------------------------------------
	   restitue l'id du dernier poll
	    ------------------------------------------------------------------------------------------ */
	function get_last_poll_id()
	{
		$sql="SELECT id FROM ".$this->polls_table." ORDER BY id desc LIMIT 0,1";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)>0)
			{ 
				$row=mysql_fetch_row($result); 
				return($row[0]);
			}
		}	
		return(0);
	}

	 /* ------------------------------------------------------------------------------------------
	   restitue les données d'un poll
	    ------------------------------------------------------------------------------------------ */
	function get_poll_values($poll_id)
	{
		$sql="SELECT * FROM ".$this->polls_table." WHERE id = $poll_id";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)>0)
			{ 
				$row=mysql_fetch_array($result);
				$sql="SELECT MAX(date) AS MaxDate FROM ".$this->polls_by_user_table." WHERE poll_id = $poll_id";
				$result=pwg_query($sql);
				if($result)
				{
					$maxdate=mysql_fetch_row($result);
					$row['maxdate']=$maxdate[0];
				}
				else { $row['maxdate'] = ""; }
				return($row);
			}
		}	
		return(false);
	}


	 /* ------------------------------------------------------------------------------------------
	   restitue un tableau de tous les polls  
	    ------------------------------------------------------------------------------------------ */
	function get_polls_list($user_id=2, $view_all=true)
	{
		$returned=array();

		$sql="SELECT id, date, title, allow_guests, visible, total, enabled, allow_comment, show_user_comment, last_vote, allowed_users, allowed_groups 
			FROM ".$this->polls_table." 
				LEFT JOIN (SELECT poll_id, MAX(date) AS last_vote FROM ".$this->polls_by_user_table." GROUP BY poll_id) AS maxdates 
				ON id=maxdates.poll_id ";
		$sql_where='';

		if($user_id==2)
		{ $sql_where.=" WHERE allow_guests = 'y' "; }

		if(!$view_all)
		{ 
			if($sql_where=='') { $sql_where.=" WHERE "; } else { $sql_where.=" AND "; }
			$sql_where.=" visible = 'y' AND enabled = 'y' "; 
		}

		$sql_order=" ORDER BY id desc";

		$result=pwg_query($sql.$sql_where.$sql_order);
		if($result)
		{
			while($row=mysql_fetch_assoc($result))
			{ 
				array_push($returned, $row);
			}
		}	
		return($returned);
	}

	 /* ------------------------------------------------------------------------------------------
	   comptabilise les visites 
	    ------------------------------------------------------------------------------------------ */
	function count_visit($poll_id, $mode)
	{	// $mode = 'before' / 'after'
		
		$sql="UPDATE ".$this->polls_table;
		if($mode=='before')
		{ $sql.=" SET visit_without_vote = visit_without_vote + 1 "; }
		else
		{ $sql.=" SET visit_after_vote = visit_after_vote + 1 "; }
		$sql.=" WHERE id = $poll_id ";
		$result=pwg_query($sql);
		return($result);
	}

	 /* ------------------------------------------------------------------------------------------
	   effectue un vote
	    ------------------------------------------------------------------------------------------ */
	function do_vote($poll_id, $vote_value, $vote_comment, $user_id, $ip)
	{
		$sql="UPDATE ".$this->polls_table."
			SET	c".$vote_value."_choose = c".$vote_value."_choose + 1,
				total = total + 1, 
				visit_without_vote = visit_without_vote - 1
			WHERE id = $poll_id";
		$result=pwg_query($sql);
		if($result)
		{
			if($user_id==2) { $vote_id = $ip; } else { $vote_id = $user_id; }
			$sql="INSERT INTO ".$this->polls_by_user_table."
				VALUES ('".$poll_id."','".$vote_id."', '".date("Y-m-d H:i:s")."', '".$vote_comment."')";
			$result=pwg_query($sql);
			return($result);
		}
		return(false);
	}
	
	 /* ------------------------------------------------------------------------------------------
	   l'utilisateur a-t'il déjà voté ?
	    ------------------------------------------------------------------------------------------ */
	function get_poll_user_vote($poll_id, $user_id, $ip)
	{
		$sql="	SELECT user_id FROM ".$this->polls_by_user_table."
			WHERE poll_id=$poll_id AND user_id = '$ip'
			UNION
			SELECT user_id FROM ".$this->polls_by_user_table." 
			WHERE poll_id=$poll_id AND user_id = '$user_id'";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)>0) 
			{ return(true); }
		}
		return(false);
	}

	 /* ------------------------------------------------------------------------------------------
	   liste des utilisateurs ayant voté
		[0] : liste
		[1] : nombre total de pages
	    ------------------------------------------------------------------------------------------ */
	function get_poll_votes($poll_id, $num_page)
	{
		$returned=array(array(), -1);
		$sql="SELECT SQL_CALC_FOUND_ROWS IF(username IS NULL, user_id, CONCAT(' ',username)) AS name
			FROM ".$this->polls_by_user_table." LEFT JOIN ".USERS_TABLE." 
			ON ".$this->polls_by_user_table.".user_id = ".USERS_TABLE.".id
			WHERE poll_id = $poll_id
			ORDER BY name
			LIMIT ".(($num_page-1)*$this->my_config['MyPolls_nbuser_per_page']).", ".$this->my_config['MyPolls_nbuser_per_page'];

		$result = pwg_query($sql);
		if($result)
		{
			$i=0;
			while($row = mysql_fetch_row($result))
			{ $returned[0][$i] = $row[0]; $i++; }

			$sql="select FOUND_ROWS()";
			$result=pwg_query($sql);
			if($result) 
			{ $row = mysql_fetch_row($result); $returned[1] = ceil($row[0]/$this->my_config['MyPolls_nbuser_per_page']); } 
			else 
			{ $returned[1] = -1; }
		}
		return($returned);
	}

	 /* ------------------------------------------------------------------------------------------
	   liste des commentaires postés
		[0] : liste
		[1] : nombre total de pages
	    ------------------------------------------------------------------------------------------ */
	function get_poll_comments($poll_id, $num_page)
	{
		$returned=array(array(), -1);
		$sql="SELECT SQL_CALC_FOUND_ROWS IF(username IS NULL, user_id, CONCAT(' ',username)) AS name, date, user_comment
			FROM ".$this->polls_by_user_table." LEFT JOIN ".USERS_TABLE." 
			ON ".$this->polls_by_user_table.".user_id = ".USERS_TABLE.".id
			WHERE poll_id = $poll_id and user_comment != ''
			ORDER BY date desc
			LIMIT ".(($num_page-1)*$this->my_config['MyPolls_nbcomment_per_page']).", ".$this->my_config['MyPolls_nbcomment_per_page'];

		$result = pwg_query($sql);
		if($result)
		{
			$i=0;
			while($row = mysql_fetch_assoc($result))
			{ $returned[0][$i] = $row; $i++; }

			$sql="select FOUND_ROWS()";
			$result=pwg_query($sql);
			if($result) 
			{ $row = mysql_fetch_row($result); $returned[1] = ceil($row[0]/$this->my_config['MyPolls_nbcomment_per_page']); } 
			else 
			{ $returned[1] = -1; }
		}
		return($returned);
	}

	 /* ------------------------------------------------------------------------------------------
	   liste des groupes (id, name))
	    ------------------------------------------------------------------------------------------ */
	function get_groups_list()
	{
		$returned=array();
		$sql="SELECT id, name FROM ".GROUPS_TABLE." ORDER BY name";
		$result=pwg_query($sql);
		if($result)
		{
			while($row=mysql_fetch_assoc($result))
			{
				array_push($returned, $row);
			}
		}
		return($returned);
	}

	/* ----------------------------------------------------------------------------------------------
		FONCTIONS DE L'ADMINISTRATEUR
	   ---------------------------------------------------------------------------------------------- */

	 /* ------------------------------------------------------------------------------------------
	   génère les onglets de la page 
	    ------------------------------------------------------------------------------------------ */
	 function make_tabsheet($selected_page)
	 { //derived from pwg function_tabsheet.inc.php
	  global $template;

		  $page['tabsheet'] = array
		  (
		    'global_view' => array
		     (
		      'caption' => l10n('MyPolls_global_view'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=global_view',
		      'selected' => ($selected_page=='global_view')	
		     ),
		    'detail_view' => array
		     (
		      'caption' => l10n('MyPolls_detail_view'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=detail_view&fMyPolls_poll_id='.$this->get_last_poll_id(),
		      'selected' => ($selected_page=='detail_view')	
		     ),
		    'create_poll' => array
		     (
		      'caption' => l10n('MyPolls_create_poll'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=create_poll',
		      'selected' => ($selected_page=='create_poll')
		     ),
		    'config' => array
		     (
		      'caption' => l10n('MyPolls_config'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=config',
		      'selected' => ($selected_page=='config')
		     )
		  );


	  if (count($page['tabsheet']) > 0)
	  {
	    $template->set_filename('tabsheet', 'admin/tabsheet.tpl');

	    foreach ($page['tabsheet'] as $tab_name => $tab)
	    {
	      $is_selected = ($tab['selected'] == 1);
	      $template->assign_block_vars
	      (
	        'tab',
	        array
	        (
	          'CLASSNAME' => ($is_selected ? 'selected_tab' : 'normal_tab'),
	          'URL' => $tab['url'],
	          'CAPTION' => $tab['caption']
	        )
	      );

	      if ($is_selected)
	      {
	        $template->assign_vars(
	          array('TABSHEET_TITLE' => '['.$tab['caption'].']'));
	      }
	    }

	    $template->assign_var_from_handle('TABSHEET', 'tabsheet');
	  }
	 }


	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la page admin
	    ------------------------------------------------------------------------------------------ */
	function display_admin_page()
	{
		$this->make_tabsheet($_REQUEST['fMyPolls_tabsheet']);

		if(isset($_POST['fMyPolls_create_new_poll']))
		{
			$this->create_poll();
		}
		elseif(isset($_POST['fMyPolls_modify_poll']))
		{
			$this->modify_poll();
		}
		elseif(isset($_POST['fMyPolls_delete_poll']))
		{
			$this->delete_poll();
		}
		else
		{
			switch($_REQUEST['fMyPolls_tabsheet'])
			{
				case 'global_view': 
					$this->display_global_view(); 
					break;
				case 'detail_view':
					if(isset($_REQUEST['fMyPolls_poll_id']))
					{ $this->display_detail_view($_REQUEST['fMyPolls_poll_id']); }
					else
					{ $this->display_detail_view($this->get_last_poll_id()); }
					break;
				case 'create_poll': 
					if(isset($_REQUEST['fMyPolls_poll_id']))
					{ $this->display_modify_poll_form($_REQUEST['fMyPolls_poll_id'], '', false); }
					else
					{ $this->display_create_poll_form('', array()); }
					break;
				case 'config': 
					$this->display_config();
					break;
			}
		}
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la configuration
	    ------------------------------------------------------------------------------------------ */
	function display_config()
	{
		global $template;
		$yes_no = array('y', 'n');
		$groups_list = $this->get_groups_list();
		$users_list=array('guest', 'generic', 'normal');

		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_config.tpl');
		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_config_title'));

		if(isset($_POST['submit']))
		{
			/* toutes zones de saisies */
			reset($this->my_config); 
			while (list($key, $val) = each($this->my_config)) 
			{ if(isset($_POST['f_'.$key])) { $this->my_config[$key] = $_POST['f_'.$key]; } }

			/* spécificité gestion groupes */
			$this->my_config['MyPolls_allowed_groups_default'] = "";
			for($i=0;$i<count($groups_list);$i++)
			{
				if(isset($_POST['f_MyPolls_allowed_groups_default_'.$groups_list[$i]['id']]))
				{ $this->my_config['MyPolls_allowed_groups_default'].=$groups_list[$i]['id']."/"; }
			}

			/* spécificité gestion utilisateurs */
			for($i=0;$i<count($users_list);$i++)
			{
				$this->my_config['MyPolls_allowed_users_default_'.$users_list[$i]]='n';
				if(isset($_POST['f_MyPolls_allowed_users_default_'.$users_list[$i]]))
				{
					if($_POST['f_MyPolls_allowed_users_default_'.$users_list[$i]]=="on")
					{ $this->my_config['MyPolls_allowed_users_default_'.$users_list[$i]]='y'; }
				}
			}

			if($this->save_config())
			{ $template->assign_var("MYPOLLS_RESULT_SAVE", "<p class='infos'>".l10n('MyPolls_config_saved')."<br/></p>"); }
		}
		/* affectation standard pour zones de saisie */
		reset($this->my_config); 
		while (list($key, $val) = each($this->my_config)) 
		{ $template->assign_var("f_".$key, $val); }

		/* gestion spécifique pour les oui/non */
		$yesno_list=array('MyPolls_visible_default' => 'MyPolls_visible_default_list',
				  'MyPolls_allow_guests_default' => 'MyPolls_allow_guests_default_list',
				  'MyPolls_enabled_default' => 'MyPolls_enabled_default_list', 
				  'MyPolls_allow_comment_default' => 'MyPolls_allow_comment_default_list', 
				  'MyPolls_show_user_comment_default' => 'MyPolls_show_user_comment_default_list' );
		reset($yesno_list);
		while (list($yesno_key, $yesno_val) = each($yesno_list)) 
		{
			reset($yes_no); 
			while (list($key, $val) = each($yes_no)) 
			{
			 	if($val==$this->my_config[$yesno_key])
				{ $select='selected'; } else { $select= ''; }

				$template->assign_block_vars(
					$yesno_val,
			      		array(
					        'VALUE' => $val,
					        'SELECT' => $select,
					        'LABEL' => l10n('MyPolls_yesno_'.$val)
			        	)
			      	);
			}
		}

		/* gestion spécifique des droits d'accès utilisateurs */
		for($i=0;$i<count($users_list);$i++)
		{
			if($this->my_config['MyPolls_allowed_users_default_'.$users_list[$i]]=='y')
			{ $template->assign_var("f_MyPolls_allowed_users_default_".$users_list[$i], "checked"); }
		}

		/* gestion spécifique des droits d'accès groupes */
		for($i=0;$i<count($groups_list);$i++)
		{
			if(strpos($this->my_config['MyPolls_allowed_groups_default'], $groups_list[$i]['id'].'/')===false)
			{ $checked = ''; }
			else
			{ $checked = 'checked'; }
			$template->assign_block_vars('allowed_group_row', 
					array('ID' => $groups_list[$i]['id'],
						'NAME' => $groups_list[$i]['name'],
						'CHECKED' => $checked
					)
			);
		}

		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la liste des sondages
	    ------------------------------------------------------------------------------------------ */
	function display_global_view()
	{
		global $template;
		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_global_view.tpl');

		$polls_list=$this->get_polls_list(1,true);
		if(count($polls_list)>1)
		{ $nb='n'; } else { $nb=count($polls_list); }

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_polls_list'));
		$template->assign_var("MYPOLLS_NB_POLLS", sprintf(l10n('MyPolls_number_of_polls'.$nb), count($polls_list)));
		
		for($i=0;$i<count($polls_list);$i++)
		{
			if($polls_list[$i]['total']>0)
			{ $last_vote = $polls_list[$i]['last_vote']; }
			else
			{ $last_vote = ""; }
			$template->assign_block_vars(
			      'mypolls_nb_polls_row',
			      array(
				'ID' => $polls_list[$i]['id'],
				'DATE' => $polls_list[$i]['date'],
				'TITLE' => $polls_list[$i]['title'],
				'ALLOW_GUESTS' => l10n('MyPolls_yesno_'.$polls_list[$i]['allow_guests']),
				'VISIBLE' => l10n('MyPolls_yesno_'.$polls_list[$i]['visible']),
				'ENABLED' => l10n('MyPolls_yesno_'.$polls_list[$i]['enabled']),
				'ALLOW_COMMENT' => l10n('MyPolls_yesno_'.$polls_list[$i]['allow_comment']),
				'SHOW_USER_COMMENT' => l10n('MyPolls_yesno_'.$polls_list[$i]['show_user_comment']),
				'TOTAL' => $polls_list[$i]['total'],
				'LAST_VOTE' => $last_vote,
				'LNK_VIEW' => $this->pagelink.'&fMyPolls_tabsheet=detail_view&fMyPolls_poll_id='.$polls_list[$i]['id'],
				'LNK_MODIFY' => $this->pagelink.'&fMyPolls_tabsheet=create_poll&fMyPolls_poll_id='.$polls_list[$i]['id']
				)
			      );
		}

		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}


	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la création d'un sondage
	    ------------------------------------------------------------------------------------------ */
	function display_create_poll_form($alertmsg, $default_values)
	{
	  	global $template;
		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_create_poll.tpl');

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_create_new_poll'));

		if(count($default_values)==0)
		{ 
			$allowed_users="";
			if($this->my_config['MyPolls_allowed_users_default_guest']=='y') { $allowed_users.="guest/"; }
			if($this->my_config['MyPolls_allowed_users_default_generic']=='y') { $allowed_users.="generic/"; }
			if($this->my_config['MyPolls_allowed_users_default_normal']=='y') { $allowed_users.="normal/"; }
			$default_values=array('title' => '', 'description' => '', 
					'visible' => $this->my_config['MyPolls_visible_default'], 
					'allow_guests' => $this->my_config['MyPolls_allow_guests_default'],
					'c1_text' => '', 'c2_text' => '', 'c3_text' => '', 'c4_text' => '', 'c5_text' => '',
					'c6_text' => '', 'c7_text' => '', 'c8_text' => '', 'c9_text' => '', 'c10_text' => '',
					'after_vote_text' => '', 'enabled' => $this->my_config['MyPolls_enabled_default'], 
					'allow_comment' => $this->my_config['MyPolls_allow_comment_default'], 
					'show_user_comment' => $this->my_config['MyPolls_show_user_comment_default'],
					'allowed_users' => $allowed_users,
					'allowed_groups' => $this->my_config['MyPolls_allowed_groups_default']); 
		}

		for($i=1;$i<=10;$i++)
		{
			if($i<3) { $need= "<sup style='color:rgb(255,255,0)'>*</sup>"; } else { $need=""; }
			$template->assign_block_vars(
			      'boucle_de_la_flemme',
			      array('NUM' => $i,
				    'NEED' => $need,
				    'CVALUE' => $default_values['c'.$i.'_text'])
			      );			
		}

		$template->assign_var('MYPOLLS_ATT_TITLE', $default_values['title']);
		$template->assign_var('MYPOLLS_ATT_DESCRIPTION', $default_values['description']);
		$template->assign_var('MYPOLLS_ATT_AFTER_VOTE_TEXT', $default_values['after_vote_text']);

		if(strpos($default_values['allowed_users'], 'guest/')!==false)
		{ $template->assign_var('MYPOLLS_ATT_ALLOWED_USERS_DEFAULT_GUEST', 'checked'); }
		if(strpos($default_values['allowed_users'], 'generic/')!==false)
		{ $template->assign_var('MYPOLLS_ATT_ALLOWED_USERS_DEFAULT_GENERIC', 'checked'); }
		if(strpos($default_values['allowed_users'], 'normal/')!==false)
		{ $template->assign_var('MYPOLLS_ATT_ALLOWED_USERS_DEFAULT_NORMAL', 'checked'); }

		$groups_list = $this->get_groups_list();
		for($i=0;$i<count($groups_list);$i++)
		{
			if(strpos($default_values['allowed_groups'], $groups_list[$i]['id'].'/')===false)
			{ $checked = ''; }
			else
			{ $checked = 'checked'; }
			$template->assign_block_vars('allowed_group_row', 
					array('ID' => $groups_list[$i]['id'],
						'NAME' => $groups_list[$i]['name'],
						'CHECKED' => $checked
					)
			);
		}

		$template->assign_var('MYPOLLS_ICN_HIDDEN', 'visibility:hidden;');


		if($default_values['enabled']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ENABLED_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ENABLED_NO', 'selected'); }

		if($default_values['visible']=='y')
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_NO', 'selected'); }

		if($default_values['allow_guests']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_NO', 'selected'); }

		if($default_values['allow_comment']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_COMMENT_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_COMMENT_NO', 'selected'); }

		if($default_values['show_user_comment']=='y')
		{ $template->assign_var('MYPOLLS_ATT_SHOW_USER_COMMENT_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_SHOW_USER_COMMENT_NO', 'selected'); }

		$template->assign_block_vars('mypolls_en_creation', array());
		if($alertmsg!='') { $template->assign_block_vars('mypolls_alert_nfo', array('TYPE' => 'errors', 'MSG' => l10n($alertmsg))); }
		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la modification d'un sondage
	    ------------------------------------------------------------------------------------------ */
	function display_modify_poll_form($poll_id, $alertmsg, $iserror)
	{
		global $template;
		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_create_poll.tpl');

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_modify_poll'));

		$poll_values=$this->get_poll_values($poll_id);

		
		for($i=1;$i<=10;$i++)
		{
			if($i<3) { $need= "<sup  style='color:rgb(255,255,0)'>*</sup>"; } else { $need=""; }
			$template->assign_block_vars(
			      'boucle_de_la_flemme',
			      array('NUM' => $i,
				    'NEED' => $need,
				    'CVALUE' => $poll_values['c'.$i.'_text']
				)
			      );			
		}
		
		$template->assign_var('MYPOLLS_ATT_TITLE', $poll_values['title']);
		$template->assign_var('MYPOLLS_ATT_DESCRIPTION', $poll_values['description']);
		$template->assign_var('MYPOLLS_ATT_AFTER_VOTE_TEXT', $poll_values['after_vote_text']);

		if(strpos($poll_values['allowed_users'], 'guest/')!==false)
		{ $template->assign_var('MYPOLLS_ATT_ALLOWED_USERS_DEFAULT_GUEST', 'checked'); }
		if(strpos($poll_values['allowed_users'], 'generic/')!==false)
		{ $template->assign_var('MYPOLLS_ATT_ALLOWED_USERS_DEFAULT_GENERIC', 'checked'); }
		if(strpos($poll_values['allowed_users'], 'normal/')!==false)
		{ $template->assign_var('MYPOLLS_ATT_ALLOWED_USERS_DEFAULT_NORMAL', 'checked'); }

		$groups_list = $this->get_groups_list();
		for($i=0;$i<count($groups_list);$i++)
		{
			if(strpos($poll_values['allowed_groups'], $groups_list[$i]['id'].'/')===false)
			{ $checked = ''; }
			else
			{ $checked = 'checked'; }
			$template->assign_block_vars('allowed_group_row', 
					array('ID' => $groups_list[$i]['id'],
						'NAME' => $groups_list[$i]['name'],
						'CHECKED' => $checked
					)
			);
		}

		$template->assign_var('MYPOLLS_LNK_VIEW', $this->pagelink.'&fMyPolls_tabsheet=detail_view&fMyPolls_poll_id='.$poll_values['id']);

		if($poll_values['enabled']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ENABLED_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ENABLED_NO', 'selected'); }

		if($poll_values['visible']=='y')
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_NO', 'selected'); }

		if($poll_values['allow_guests']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_NO', 'selected'); }

		if($poll_values['allow_comment']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_COMMENT_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_COMMENT_NO', 'selected'); }

		if($poll_values['show_user_comment']=='y')
		{ $template->assign_var('MYPOLLS_ATT_SHOW_USER_COMMENT_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_SHOW_USER_COMMENT_NO', 'selected'); }

		if($iserror) { $msg_type = 'errors'; } else { $msg_type = 'infos'; }
		if($alertmsg!='') { $template->assign_block_vars('mypolls_alert_nfo', array('TYPE' => $msg_type, 'MSG' => l10n($alertmsg))); }

		$template->assign_block_vars('mypolls_en_modification', array('ID' => $poll_id));
		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la consultation d'un sondage
	    ------------------------------------------------------------------------------------------ */
	function display_detail_view($poll_id)
	{
	  	global $template;

		if(!isset($_REQUEST['fPageNumVoteList']))
		{ $pagenum = 1; }
		else
		{ $pagenum = $_REQUEST['fPageNumVoteList']; }

		if(!isset($_REQUEST['fPageNumCommentList']))
		{ $pagenumc = 1; }
		else
		{ $pagenumc = $_REQUEST['fPageNumCommentList']; }


		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_detail_view.tpl');

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_detail_view_title'));

		$poll_values=$this->get_poll_values($poll_id);
		$poll_votes=$this->get_poll_votes($poll_id, $pagenum);
		$poll_comments=$this->get_poll_comments($poll_id, $pagenumc);

		$i=1;
		while(($i<=10)&&($poll_values['c'.$i.'_text']!=''))
		{
			if($poll_values['total']>0)
			{ $pct=round(100*$poll_values['c'.$i.'_choose'] / $poll_values['total'], 2); }
			else
			{ $pct=0; }

			$barwidth=ceil($pct * $this->my_config['MyPolls_MaxBarWidth']/100);

			$template->assign_block_vars(
			      'mypolls_questions_row',
			      array('ID' => $i,
				    'QUESTION' => $poll_values['c'.$i.'_text'],
				    'NBANSWERS' => $poll_values['c'.$i.'_choose'],
				    'PCT' => $pct."%",
				    'BARWIDTH' => $barwidth
				)
			      );
			$i++;
		}

		// liste des votants 
		for($i=0;$i<count($poll_votes[0]);$i++)
		{
			if(is_ip($poll_votes[0][$i]))
			{
				$ip_geolocalisation='<a href="http://www.geoiptool.com/fr/?IP='.$poll_votes[0][$i].'" title="Geo IP localisation" target="_blank">['.l10n('MyPolls_IP_geolocalisation').'] </a>';
				$ip_adress='<a href="http://www.ripe.net/whois?form_type=simple&amp;full_query_string=&amp;searchtext='.$poll_votes[0][$i].'+&amp;do_search=Search" title="Ripe Whois" target="_blank">'.$poll_votes[0][$i].'</a>';
			}
			else 
			{
				$ip_geolocalisation='';
				$ip_adress=$poll_votes[0][$i];
			}

			$template->assign_block_vars(
				'mypolls_users_vote_row',
				array('USERNAME' => $ip_geolocalisation.$ip_adress
				)
			);
		}
		// pagination des votants
		if($poll_votes[1]>1) { $plural="s"; } else { $plural=""; }
		$pages_links=l10n("MyPolls_page".$plural."_label")." : ";
		for($i=1;$i<=$poll_votes[1];$i++)
		{
			if($i==$pagenum) 
			{ $pages_links.=" $i "; } 
			else
			{
				$pages_links.=format_link(" $i ", $this->pagelink."&fMyPolls_tabsheet=detail_view&fMyPolls_poll_id=$poll_id&fPageNumVoteList=$i&fPageNumCommentList=$pagenumc");
			}
		} 
		if($poll_votes[1]<=0)
		{ $pages_links=l10n('MyPolls_detail_no_vote'); }

		// liste de commentaires
		for($i=0;$i<count($poll_comments[0]);$i++)
		{
			$template->assign_block_vars(
				'mypolls_users_comment_row',
				array('DATE' => $poll_comments[0][$i]['date'],
					'USER' => $poll_comments[0][$i]['name'],
					'COMMENT' => $poll_comments[0][$i]['user_comment']
				)
		 	);
		}

		//pagination des commentaires
		if($poll_comments[1]>1) { $plural="s"; } else { $plural=""; }
		$pages_linksc=l10n("MyPolls_page".$plural."_label")." : ";
		for($i=1;$i<=$poll_comments[1];$i++)
		{
			if($i==$pagenumc) 
			{ $pages_linksc.=" $i "; } 
			else
			{
				$pages_linksc.=format_link(" $i ", $this->pagelink."&fMyPolls_tabsheet=detail_view&fMyPolls_poll_id=$poll_id&fPageNumVoteList=$pagenum&fPageNumCommentList=$i");
			}
		}
		if($poll_comments[1]<=0)
		{ $pages_linksc=l10n('MyPolls_detail_no_comment'); }

		//liste des utilisateurs
		if($poll_values['allowed_users']=='')
		{ 
			$tmp=l10n('MyPolls_detail_no_user_allowed');
		}
		else
		{
			$tmp=array();
			$list=array('guest', 'generic', 'normal');
			for($i=0;$i<count($list);$i++)
			{
				if(strpos($poll_values['allowed_users'], $list[$i].'/')!==false)
				{ array_push($tmp, l10n('user_status_'.$list[$i])); }
			}
			$tmp = implode(', ', $tmp);
		}
		$template->assign_var('MYPOLLS_ATT_ALLOWED_USERS', $tmp);

		//liste des groupes
		if($poll_values['allowed_groups']=='')
		{ 
			$tmp=l10n('MyPolls_detail_no_group_allowed');
		}
		else
		{
			$tmp=array();
			$list=$this->get_groups_list();
			for($i=0;$i<count($list);$i++)
			{
				if(strpos($poll_values['allowed_groups'], $list[$i]['id'].'/')!==false)
				{ array_push($tmp, $list[$i]['name']); }
			}
			$tmp = implode(', ', $tmp);
		}
		$template->assign_var('MYPOLLS_ATT_ALLOWED_GROUPS', $tmp);


		$template->assign_var('MYPOLLS_LNK_MODIFY', $this->pagelink.'&fMyPolls_tabsheet=create_poll&fMyPolls_poll_id='.$poll_values['id']);
		$template->assign_var('MYPOLLS_PAGES_LINKS_COM', $pages_linksc);
		$template->assign_var('MYPOLLS_PAGES_LINKS', $pages_links);
		$template->assign_var('MYPOLLS_MAXBARWIDTH', $this->my_config['MyPolls_MaxBarWidth']);
		$template->assign_var('MYPOLLS_ATT_ID', $poll_values['id']);
		$template->assign_var('MYPOLLS_ATT_DATE', $poll_values['date']);
		$template->assign_var('MYPOLLS_ATT_TITLE', $poll_values['title']);
		$template->assign_var('MYPOLLS_ATT_TOTAL', $poll_values['total']);
		$template->assign_var('MYPOLLS_ATT_LASTDATE', $poll_values['maxdate']);
		$template->assign_var('MYPOLLS_ATT_VISIT_WITHOUT_VOTE', $poll_values['visit_without_vote']);
		$template->assign_var('MYPOLLS_ATT_VISIT_AFTER_VOTE', $poll_values['visit_after_vote']);
		$template->assign_var('MYPOLLS_ATT_ENABLED', l10n('MyPolls_yesno_'.$poll_values['enabled']));
		$template->assign_var('MYPOLLS_ATT_VISIBLE', l10n('MyPolls_yesno_'.$poll_values['visible']));
		$template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS', l10n('MyPolls_yesno_'.$poll_values['allow_guests']));
		$template->assign_var('MYPOLLS_ATT_ALLOW_COMMENT', l10n('MyPolls_yesno_'.$poll_values['allow_comment']));
		$template->assign_var('MYPOLLS_ATT_SHOW_USER_COMMENT', l10n('MyPolls_yesno_'.$poll_values['show_user_comment']));
		$template->assign_var('MYPOLLS_ATT_DESCRIPTION', $poll_values['description']);
		$template->assign_var('MYPOLLS_ATT_AFTER_VOTE_TEXT', $poll_values['after_vote_text']);
		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}

	 /* ------------------------------------------------------------------------------------------
	   prépare les données allowed_users et allowed_groups
		[0] : users_list
		[1] : groups_list
	    ------------------------------------------------------------------------------------------ */
	function format_allowed()
	{
		$groups_list = $this->get_groups_list();
		$users_list=array('guest', 'generic', 'normal');

		/* spécificité gestion groupes */
		$fgroups_list = "";
		for($i=0;$i<count($groups_list);$i++)
		{
			if(isset($_POST['fMyPolls_att_allowed_groups_'.$groups_list[$i]['id']]))
			{ $fgroups_list.=$groups_list[$i]['id']."/"; }
		}

		/* spécificité gestion utilisateurs */
		$fusers_list = "";
		for($i=0;$i<count($users_list);$i++)
		{
			if(isset($_POST['fMyPolls_att_allowed_users_'.$users_list[$i]]))
			{
				if($_POST['fMyPolls_att_allowed_users_'.$users_list[$i]]=="on")
				{ $fusers_list.=$users_list[$i].'/'; }
			}
		}

		return(array($fusers_list, $fgroups_list));
	}
	 /* ------------------------------------------------------------------------------------------
	   création d'un sondage dans la base 
	    ------------------------------------------------------------------------------------------ */
	function create_poll()
	{
		$allowed = $this->format_allowed();
	
		$sql="INSERT INTO ".$this->polls_table."
		 VALUES ('', '".date("Y-m-d H:i:s")."', 
			'".$_REQUEST['fMyPolls_att_title']."', 
			'".$_REQUEST['fMyPolls_att_description']."', 
			'".substr($_REQUEST['fMyPolls_att_allow_guests'],0,1)."', 
			'".substr($_REQUEST['fMyPolls_att_visible'],0,1)."', 
			'".$_REQUEST['fMyPolls_att_c1_text']."', '',
			'".$_REQUEST['fMyPolls_att_c2_text']."', '',
			'".$_REQUEST['fMyPolls_att_c3_text']."', '',
			'".$_REQUEST['fMyPolls_att_c4_text']."', '',
			'".$_REQUEST['fMyPolls_att_c5_text']."', '',
			'".$_REQUEST['fMyPolls_att_c6_text']."', '',
			'".$_REQUEST['fMyPolls_att_c7_text']."', '',
			'".$_REQUEST['fMyPolls_att_c8_text']."', '',
			'".$_REQUEST['fMyPolls_att_c9_text']."', '',
			'".$_REQUEST['fMyPolls_att_c10_text']."', '', '', '', '',
			'".$_REQUEST['fMyPolls_att_after_vote_text']."',
			'".$_REQUEST['fMyPolls_att_enabled']."',
			'".$_REQUEST['fMyPolls_att_allow_comment']."',
			'".$_REQUEST['fMyPolls_att_show_user_comment']."', 
			'".$allowed[0]."', 
			'".$allowed[1]."')";
		$result=pwg_query($sql);
		if($result)
		{
			$this->display_modify_poll_form(mysql_insert_id(), 'MyPolls_create_is_ok', false);
		}
		else
		{
			$default_values=array('title' => $_REQUEST['fMyPolls_att_title'], 
					'description' => $_REQUEST['fMyPolls_att_description'], 
					'visible' => substr($_REQUEST['fMyPolls_att_visible'],0,1), 
					'allow_guests' => substr($_REQUEST['fMyPolls_att_allow_guests'],0,1),
					'c1_text' => $_REQUEST['fMyPolls_att_c1_text'], 
					'c2_text' => $_REQUEST['fMyPolls_att_c2_text'], 
					'c3_text' => $_REQUEST['fMyPolls_att_c3_text'],  
					'c4_text' => $_REQUEST['fMyPolls_att_c4_text'],  
					'c5_text' => $_REQUEST['fMyPolls_att_c5_text'], 
					'c6_text' => $_REQUEST['fMyPolls_att_c6_text'],  
					'c7_text' => $_REQUEST['fMyPolls_att_c7_text'],  
					'c8_text' => $_REQUEST['fMyPolls_att_c8_text'],  
					'c9_text' => $_REQUEST['fMyPolls_att_c9_text'],  
					'c10_text' => $_REQUEST['fMyPolls_att_c10_text'],
					'after_vote_text' => $_REQUEST['fMyPolls_att_after_vote_text'],
					'enabled' => $_REQUEST['fMyPolls_att_enabled'],
					'allow_comment' => $_REQUEST['fMyPolls_att_allow_comment'],
					'show_user_comment' => $_REQUEST['fMyPolls_att_show_user_comment'],
					'allowed_users' => $allowed[0],
					'allowed_groups' => $allowed[1]); 
			$this->display_create_poll_form('MyPolls_create_is_ko', $default_values);
		}
	}

	 /* ------------------------------------------------------------------------------------------
	   modification d'un sondage dans la base 
	    ------------------------------------------------------------------------------------------ */
	function modify_poll()
	{
		$allowed = $this->format_allowed();

		$sql="UPDATE ".$this->polls_table."
		SET 	title = '".$_REQUEST['fMyPolls_att_title']."', 
			description = '".$_REQUEST['fMyPolls_att_description']."', 
			allow_guests = '".substr($_REQUEST['fMyPolls_att_allow_guests'],0,1)."', 
			visible = '".substr($_REQUEST['fMyPolls_att_visible'],0,1)."', 
			c1_text = '".$_REQUEST['fMyPolls_att_c1_text']."', 
			c2_text = '".$_REQUEST['fMyPolls_att_c2_text']."', 
			c3_text = '".$_REQUEST['fMyPolls_att_c3_text']."', 
			c4_text = '".$_REQUEST['fMyPolls_att_c4_text']."', 
			c5_text = '".$_REQUEST['fMyPolls_att_c5_text']."', 
			c6_text = '".$_REQUEST['fMyPolls_att_c6_text']."', 
			c7_text = '".$_REQUEST['fMyPolls_att_c7_text']."', 
			c8_text = '".$_REQUEST['fMyPolls_att_c8_text']."', 
			c9_text = '".$_REQUEST['fMyPolls_att_c9_text']."', 
			c10_text = '".$_REQUEST['fMyPolls_att_c10_text']."',
			after_vote_text = '".$_REQUEST['fMyPolls_att_after_vote_text']."', 
			enabled = '".substr($_REQUEST['fMyPolls_att_enabled'],0,1)."',
			allow_comment = '".substr($_REQUEST['fMyPolls_att_allow_comment'],0,1)."' ,
			show_user_comment = '".substr($_REQUEST['fMyPolls_att_show_user_comment'],0,1)."', 
			allowed_users = '".$allowed[0]."',
			allowed_groups = '".$allowed[1]."' 
		WHERE id = ".$_REQUEST['fMyPolls_att_id'];
		$result=pwg_query($sql);
		if($result)
		{
			$this->display_modify_poll_form($_REQUEST['fMyPolls_att_id'], 'MyPolls_modify_is_ok', false);
		}
		else
		{
			$this->display_modify_poll_form($_REQUEST['fMyPolls_att_id'], 'MyPolls_modify_is_ko', true);
		}
	}

	 /* ------------------------------------------------------------------------------------------
	   suppression d'un sondage dans la base 
	    ------------------------------------------------------------------------------------------ */
	function delete_poll()
	{
		$sql="DELETE FROM ".$this->polls_table." WHERE id = ".$_REQUEST['fMyPolls_att_id'];
		$result=pwg_query($sql);
		if($result)
		{
			$this->display_global_view();
		}
		else
		{
			$this->display_modify_poll_form($_REQUEST['fMyPolls_att_id'], 'MyPolls_delete_is_ko', true);
		}
	}


	/* ----------------------------------------------------------------------------------------------
		FONCTIONS DE LA GALLERIE
	   ---------------------------------------------------------------------------------------------- */

	function allowed_group($allowed_groups, $user_id)
	{
		if($allowed_groups=='')
		{ return(true); }
		$returned=false;
		$tmp=explode('/', $allowed_groups);
		array_pop($tmp);
		$tmp=implode(', ', $tmp);
		$sql="SELECT * FROM ".USER_GROUP_TABLE." 
			WHERE user_id = ".$user_id." AND group_id IN(".$tmp.")";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)>0)	
			{ $returned = true; }
		}
		return($returned);
	}

	/* ----------------------------------------------------------------------------------------------
		Met à jour le menu de la gallerie
	   ---------------------------------------------------------------------------------------------- */
	function maj_menubar()
	{
		global $template, $user, $lang;

		include_once(get_language_filepath('plugin.lang.php', MYPOLLS_PATH));

		$tpl_code = '
		<!-- BEGIN mypolls -->
		<dl id="mbMyPolls">
		<dt>{mypolls.TITLE}</dt>
		<dd><ul>
		<!-- BEGIN link -->
		<li><a href="{mypolls.link.URL}">{mypolls.link.LABEL}</a></li>
		<!-- END link -->
		</ul></dd></dl>
		<!-- END mypolls -->
		';
		// compatibilité avec le plugin "MenuBarManager" 
		// [http://phpwebgallery.net/ext/extension_view.php?eid=164]
		if (function_exists('set_menubar_manager_data'))
		{
			set_menubar_manager_data('MyPolls', $tpl_code, 'begin');
		}
		else
		{	//plugin "MenuBarManager" non installé
			$template->loadfile('menubar');
			$template->uncompiled_code['menubar'] = str_replace('<div id="menubar">', 
										'<div id="menubar">'.$tpl_code, $template->uncompiled_code['menubar']);
		}

		$polls_list=$this->get_polls_list($user['user_id'], false);
		if(!is_admin())
		{
			$i=0;
			while($i<count($polls_list))
			{
				if(strpos($polls_list[$i]['allowed_users'], $user['status'].'/')===false)
				{
					array_splice($polls_list, $i, 1);
				}
				elseif(!$this->allowed_group($polls_list[$i]['allowed_groups'], $user['id']))
				{
					array_splice($polls_list, $i, 1);
				}
				else
				{ $i++; }
			}
		}

		if(count($polls_list)>0)
		{
			if($this->my_config['MyPolls_MenuBar_Title']!='')
			{ $template->assign_block_vars('mypolls', array('TITLE' => $this->my_config['MyPolls_MenuBar_Title'])); }
			else
			{ $template->assign_block_vars('mypolls', array('TITLE' => l10n('MyPolls_menubar_default_title'))); }

			if(is_admin())
			{
				$template->assign_block_vars('mypolls.link', array(
					'LABEL' => "<i>".l10n('MyPolls_create_a_poll')."</i>",
					'URL' => PHPWG_ROOT_PATH.'admin.php?page=plugin&section=mypolls/admin/plugin_admin.php&fMyPolls_tabsheet=create_poll'
					)
				);
			}

			for($i=0;$i<count($polls_list);$i++)
			{
				if(is_admin())
				{ $lnk_edit = "</a> --- <a href='".PHPWG_ROOT_PATH."admin.php?page=plugin&section=mypolls/admin/plugin_admin.php&fMyPolls_tabsheet=create_poll&fMyPolls_poll_id=".$polls_list[$i]['id']."'>[".l10n('MyPolls_menubar_edit')."]"; }
				else
				{ $lnk_edit = ''; }

				$template->assign_block_vars('mypolls.link', array(
					'LABEL' => $polls_list[$i]['title'].$lnk_edit,
					'URL' => PHPWG_ROOT_PATH.'index.php?/mypolls/'.$polls_list[$i]['id']
					)
				);
			}
		}
	}

	/* ----------------------------------------------------------------------------------------------
		gestion de la section "mypolls" (utilisée dans les logs)
	   ---------------------------------------------------------------------------------------------- */
	function init_section_mypolls()
	{
		global $tokens, $page;
		
		if ($tokens[0] == 'mypolls')
		{ $page['section'] = 'mypolls'; }
	}

	/* ----------------------------------------------------------------------------------------------
		gestion des pages "mypolls"
	   ---------------------------------------------------------------------------------------------- */
	function index_mypolls()
	{
		global $page, $user;

		if($page['section'] == 'mypolls')
		{
			$poll_id=explode('mypolls/', $_SERVER['REQUEST_URI']);
			$poll_id=explode('&', $poll_id[1]);

			if((isset($_POST['submit_poll_answer']))&&(!$this->get_poll_user_vote($poll_id[0], $user['user_id'], $_SERVER['REMOTE_ADDR'])))
			{
				if(!isset($_REQUEST['fMyPolls_comment']))
				{ $_REQUEST['fMyPolls_comment']=''; }
				$this->do_vote($poll_id[0], $_REQUEST['fMyPolls_answer'], $_REQUEST['fMyPolls_comment'], $user['user_id'], $_SERVER['REMOTE_ADDR']);
			}
			$this->display_poll_page($poll_id[0]);
		}
	}

	/* ----------------------------------------------------------------------------------------------
		affichage de la page en mode formulaire ou résultat
	   ---------------------------------------------------------------------------------------------- */
	function display_poll_page($poll_id)
	{
		global $template, $user;

		$template->set_filename('body_page', dirname(__FILE__).'/plugin_polls_requests.tpl');

		if(!isset($_REQUEST['fPageNumCommentList']))
		{ $pagenum = 1; }
		else
		{ $pagenum = $_REQUEST['fPageNumCommentList']; }

		$poll_values=$this->get_poll_values($poll_id);
		$poll_comments=$this->get_poll_comments($poll_id, $pagenum);

		/* vérification des droits d'accès */
		$allowed_to_see = true;
		if(strpos($poll_values['allowed_users'], $user['status'])===false)
		{ $allowed_to_see = false; }

		if($poll_values['allowed_groups']!='')
		{
			if(!$this->allowed_group($poll_values['allowed_groups'], $user['id']))
			{ $allowed_to_see = false; }
		}
		if(is_admin()) { $allowed_to_see = true; }
		if(!$allowed_to_see)
		{ page_not_found('User not allowed', 'index.php?'); }
		

		if((($poll_values['allow_guests']=='n')&&($user['user_id']==2))||($poll_values['enabled']=='n'))
		{
			page_not_found('This page does not exist', 'index.php?');
			return(false);
		}

		$template->assign_var('TITLE', $poll_values['title']);
		$template->assign_var('MYPOLLS_DESCRIPTION', $poll_values['description']);

		if($user['user_id']==2)
		{ $generic_text = $this->my_config['MyPolls_generic_text_guests']; }
		else
		{ $generic_text = $this->my_config['MyPolls_generic_text_users']; }
		if($generic_text!='')
		{ $template->assign_block_vars('poll_generic_text', array('TEXT' => $generic_text)); }

		$template->assign_var('PLUGIN_INDEX_ACTIONS' , 
			'<li><a href="'.make_index_url().'" title="'.l10n('return to homepage').'">
			<img src="'.$template->themeconf['icon_dir'].'/home.png" class="button" alt="'.l10n('home').'"/></a></li>');

		if (is_admin()) 
		{
			$template->assign_block_vars('edit',
				array('URL' => PHPWG_ROOT_PATH."admin.php?page=plugin&section=mypolls/admin/plugin_admin.php&fMyPolls_tabsheet=create_poll&fMyPolls_poll_id=".$poll_id)
			);
		}


		if($this->get_poll_user_vote($poll_id, $user['user_id'], $_SERVER['REMOTE_ADDR']))
		{ // a déjà voté
			$this->count_visit($poll_id, 'after');

			$template->assign_block_vars('poll_vote_result', array(
						'TOTAL' => $poll_values['total'],
						'MAXBARWIDTH' => $this->my_config['MyPolls_MaxBarWidth'],
						'AFTER_VOTE_TEXT' => $poll_values['after_vote_text']
					));

			$i=1;
			while(($i<=10)&&($poll_values['c'.$i.'_text']!=''))
			{
				if($poll_values['total']>0)
				{ $pct=round(100*$poll_values['c'.$i.'_choose'] / $poll_values['total'], 2); }
				else
				{ $pct=0; }

				$barwidth=ceil($pct * $this->my_config['MyPolls_MaxBarWidth']/100);

				$template->assign_block_vars(
				      'poll_vote_result.mypolls_questions_row',
				      array('ID' => $i,
					    'QUESTION' => $poll_values['c'.$i.'_text'],
					    'NBANSWERS' => $poll_values['c'.$i.'_choose'],
					    'PCT' => $pct."%",
					    'BARWIDTH' => $barwidth
					)
				      );
				$i++;
			}

			// liste de commentaires
			if(($poll_values['show_user_comment']=='y')&(count($poll_comments[0])>0))
			{
				//pagination des commentaires
				if($poll_comments[1]>1) { $plural="s"; } else { $plural=""; }
				$pages_links=l10n("MyPolls_page".$plural."_label")." : ";
				for($i=1;$i<=$poll_comments[1];$i++)
				{
					if($i==$pagenum) 
					{ $pages_links.=" $i "; } 
					else
					{
						$pages_links.='<a href="'.PHPWG_ROOT_PATH.'index.php?/mypolls/'.$poll_id.'&fPageNumCommentList='.$i.'">'.$i.'</a>';
					}
				}
				$template->assign_var('PAGES_LINKS', $pages_links);

				for($i=0;$i<count($poll_comments[0]);$i++)
				{
					$template->assign_block_vars(
						'poll_vote_result.allow_comment.comments',
						array('DATE' => $poll_comments[0][$i]['date'],
							'USER' => $poll_comments[0][$i]['name'],
							'COMMENT' => $poll_comments[0][$i]['user_comment']
					)
				      );
				}
			}
		}
		else
		{ // n'a jamais voté
			$this->count_visit($poll_id, 'before');

			if($poll_values['allow_comment']=='y')
			{ $template->assign_block_vars('poll_vote_form.allow_comment', array()); }
			else
			{ $template->assign_block_vars('poll_vote_form', array()); }

			$i=1;
			while(($i<=10)&&($poll_values['c'.$i.'_text']!=''))
			{
				if($i==1) { $checked='checked'; } else { $checked=''; }
				$template->assign_block_vars('poll_vote_form.poll_questions', 
						array('LABEL' => $poll_values['c'.$i.'_text'],
							'NUM' => $i,
							'SELECTED' => $checked
						)
					);
				$i++;
			}
		}

		unset($template->_tpldata['mode_posted.']);
		unset($template->_tpldata['mode_created.']);
		$template->assign_var_from_handle('PLUGIN_INDEX_CONTENT_BEGIN', 'body_page');
	}
}


?>
